KingOfTheJungleUI = KingOfTheJungle:NewModule("User Interface")

local L = AceLibrary("AceLocale-2.2"):new("KingOfTheJungle")
local data_tab = {}
local portrait = nil

function KingOfTheJungleUI:showUI()   
	optionsTab = self:createMainFrame()			
	
	local checkbox = self:createUICheckBox(optionsTab,L["Pet Hungry"],L["When checked warns if pet is hungry"],30,-80)
	checkbox:SetChecked(KingOfTheJungle.db.char.warnPetHungry)
	checkbox:SetScript("OnClick", function()
		KingOfTheJungle.db.char.warnPetHungry = checkbox:GetChecked()		
	end)
	
	--self:createTabOptions(data_tab,self.uiframe,L["Options"],31,-21)
	--self:createTabOptions(data_tab,self.uiframe,"Diets",100,-21)
	--self:tabActive(data_tab[1])
		
	optionsTab:Show()
end

function KingOfTheJungleUI:createMainFrame()
	local f = CreateFrame("Frame",nil,UIParent)
	f:SetFrameStrata("BACKGROUND")	
	f:SetWidth(384)  
	f:SetHeight(512) 
	f:SetHitRectInsets(0,30,0,45)
	f:SetPoint("CENTER",0,0)
	f:SetClampedToScreen(true)
	f:SetMovable(true)	
	f:EnableMouse(true)
    f:RegisterForDrag("LeftButton")	
	
--~ BACKGROUND TEXTURES	

--~ Portrait
	if not portrait then
		portrait = f:CreateTexture(nil, "BACKGROUND")	
	end

	portrait:SetWidth(60)
	portrait:SetHeight(60)	
	portrait:SetPoint("TOPLEFT", f,"TOPLEFT",7,-6)

--~ BORDER TEXTURES
	local t = f:CreateTexture(nil, "BORDER")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-TopLeft.blp")
	t:SetWidth(256)	
	t:SetHeight(256)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",2,-1)	
	
	t = f:CreateTexture(nil, "BORDER")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-TopRight.blp")
	t:SetWidth(128)
	t:SetHeight(256)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",258,-1)	
	
	t = f:CreateTexture(nil, "BORDER")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-BottomLeft.blp")
	t:SetWidth(256)
	t:SetHeight(256)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",2,-257)	
	
	t = f:CreateTexture(nil, "BORDER")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-BottomRight.blp")
	t:SetWidth(128)
	t:SetHeight(256)
	t:SetPoint("TOPLEFT", f,"TOPLEFT",258,-257)	

--~ ARTWORK TEXTURES
	t = f:CreateTexture(nil, "ARTWORK")	
	t:SetTexture("Interface\\TalentFrame\\HunterBeastMastery-TopLeft.blp")
	t:SetWidth(256)
	t:SetHeight(256)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",23,-77)	
	
	t = f:CreateTexture(nil, "ARTWORK")	
	t:SetTexture("Interface\\TalentFrame\\HunterBeastMastery-TopRight.blp")
	t:SetWidth(64)
	t:SetHeight(256)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",279,-77)	
	
	t = f:CreateTexture(nil, "ARTWORK")	
	t:SetTexture("Interface\\TalentFrame\\HunterBeastMastery-BottomLeft.blp")
	t:SetWidth(256)
	t:SetHeight(128)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",23,-333)	
	
	t = f:CreateTexture(nil, "ARTWORK")	
	t:SetTexture("Interface\\TalentFrame\\HunterBeastMastery-BottomRight.blp")
	t:SetWidth(64)
	t:SetHeight(128)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",279,-333)	

--~ FONTS
	local font = f:CreateFontString(nil, "ARTWORK", "GameFontNormal")
 	font:SetPoint("TOP", f,"TOP",0,-20)	
	font:SetText(L["King of the Jungle"])	

--~ BUTTONS
	local b = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	b:SetPoint("CENTER", f, "TOPRIGHT", -44, -25)
	
--~ EVENT HANDLERS	
	f:SetScript("OnDragStart", function()
		this:StartMoving()		
	end)
	f:SetScript("OnDragStop", function()
		this:StopMovingOrSizing()		
	end)
	f:SetScript("OnUpdate", function()
		if UnitExists("pet") then
			SetPortraitTexture(portrait,"pet")
		else
			portrait:SetTexture("Interface\\CharacterFrame\\TemporaryPortrait-Monster.blp")
		end
	end)	
	
	return f
end

function KingOfTheJungleUI:createTabOptions(data,parent,text,xpos,ypos)	
	local f = CreateFrame("Button",nil,parent)
	table.insert(data, f) 
	
	f:SetPoint("BOTTOMLEFT",parent,"BOTTOMLEFT",xpos,ypos)
		
	f:SetText(text)
	f:SetWidth(f:GetTextWidth()+40)
	f:SetHeight(32)
	f:SetFrameLevel( f:GetFrameLevel() + 4)
	f:Hide()
	
	f:SetTextFontObject( GameFontNormalSmall )
	f:SetDisabledFontObject( GameFontHighlightSmall )
	f:SetHighlightFontObject( GameFontHighlightSmall )				
	
	local t = f:CreateTexture(nil, "BACKGROUND")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ActiveTab")
	t:SetWidth(20)
	t:SetHeight(32)
	t:SetTexCoord(0,0.15625,0,1.0)	
	t:SetPoint("LEFT", f,"LEFT",-20,0)
	f.tld = t -- LeftDisabled

	t = f:CreateTexture(nil, "BACKGROUND")
	t:ClearAllPoints()
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ActiveTab")
	t:SetWidth( f:GetWidth() )
	t:SetHeight(32)
	t:SetTexCoord(0.15625,0.84375,0,1.0)
	t:SetPoint("LEFT", f, "LEFT",0,0)
	f.tmd = t -- MiddleDisabled
				
	t = f:CreateTexture(nil, "BACKGROUND")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ActiveTab")
	t:SetWidth(20)
	t:SetHeight(32)
	t:SetTexCoord(0.84375,1.0,0,1.0)
	t:SetPoint("LEFT", f, "LEFT",f:GetWidth(),0)
	f.trd = t -- RightDisabled
		
	t = f:CreateTexture(nil, "BACKGROUND")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-InActiveTab")
	t:SetWidth(20)
	t:SetHeight(32)
	t:SetTexCoord(0,0.15625,0,1.0)
	t:SetPoint("LEFT", f,"LEFT",-20,0)
	f.tl = t -- Left

	t = f:CreateTexture(nil, "BACKGROUND")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-InActiveTab")
	t:SetWidth( f:GetWidth() )
	t:SetHeight(32)
	t:SetTexCoord(0.15625,0.84375,0,1.0)
	t:SetPoint("LEFT", f, "LEFT",0,0)
	f.tm = t -- Middle

	t = f:CreateTexture(nil, "BACKGROUND")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-InActiveTab")
	t:SetWidth(20)
	t:SetHeight(32)
	t:SetTexCoord(0.84375,1.0,0,1.0)
	t:SetPoint("LEFT", f, "LEFT",f:GetWidth(),0)
	f.tr = t -- Right

	t = f:CreateTexture()	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-Tab-Highlight")
	t:SetBlendMode("ADD")
	t:SetPoint("LEFT", -10, 2)
	t:SetPoint("RIGHT", 10, 2)
	--t:SetWidth( f:GetWidth() + 30 )
	f:SetHighlightTexture( t )
	
	self:tabInactive(f)		
	
	local id = getn(data)
	
	f:SetScript("OnClick", function() 
		self:handleTabButtonOnClick(id)
	end )
	
	f:Show()	
end

function KingOfTheJungleUI:handleTabButtonOnClick(id)
	for i,v in ipairs(data_tab) do 		
		if i == id then			
			self:tabActive(v)
		else			
			self:tabInactive(v)
		end
	end
end

function KingOfTheJungleUI:tabActive(f)
	f.tld:Show()
	f.tmd:Show()
	f.trd:Show()	
	f.tl:Hide()
	f.tm:Hide()
	f.tr:Hide()
	
	f:Disable()
end

function KingOfTheJungleUI:tabInactive(f)
	f.tld:Hide()
	f.tmd:Hide()
	f.trd:Hide()	
	f.tl:Show()
	f.tm:Show()
	f.tr:Show()
	
	f:Enable()
end


function KingOfTheJungleUI:createUICheckBox(parent,text,tooltip,xpos,ypos) 
	local checkbutton = CreateFrame("CheckButton",nil,parent,"UICheckButtonTemplate")
	checkbutton:SetPoint("TOPLEFT", parent,"TOPLEFT",xpos,ypos)	
	
	checkbutton.Text1 = checkbutton:CreateFontString(nil, "ARTWORK", "GameFontNormal")	
	checkbutton.Text1:SetText(text)
	checkbutton.Text1:SetJustifyH("LEFT")
	checkbutton.Text1:SetPoint("RIGHT", checkbutton, "RIGHT", checkbutton.Text1:GetStringWidth(), 0)	
	
	checkbutton:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this, checkbutton)
		GameTooltip:SetText(tooltip, 1.0, 1.0, 1.0)
		GameTooltip:Show()		
	end)
	
	checkbutton:SetScript("OnLeave", function()
		GameTooltip:Hide()	
	end)
	
	return checkbutton
end